<template>
    <v-container class="py-0">
        <v-toolbar flat>
            <v-toolbar-title class="text-decoration-underline font-weight-black">
                {{ $t("LNG_FIELDS_TITLE") }}
            </v-toolbar-title>
            <v-divider class="mx-8" inset vertical/>
            <v-spacer/>
            <field-edit v-if="isCurrentUserAllowed" v-bind:is-add="true" @updated="updateFields"/>
        </v-toolbar>
        <br><br>
        <v-card class="field">
            <table-edit v-if="isCurrentUserAllowed" :key="tableEditKey" :fields="fields" @update="loadFields"/>
            <table-students v-else :fields="fields"/>
        </v-card>
    </v-container>
</template>

<script>
import { mapGetters } from "vuex";
import TableEdit from '@/components/TableEdit.component';
import TableStudents from '@/components/TableStudents.component';
import FieldEdit from '@/components/FieldEdit.component'
import Services from "@/services/api";
import { SET_LOADING } from "@/store/mutations.type";

export default {
    name: 'Fields',
    components: { TableEdit, TableStudents, FieldEdit },
    data: () => ({
        tableEditKey: 0,
        fields: []
    }),
    computed: {
        ...mapGetters([
            'user'
        ]),
        isCurrentUserAllowed() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        }
    },
    methods: {
        updateFields() { // Force the component to re-render changing its key
            this.tableEditKey += 1;
            this.loadFields();
        },
        async loadFields() {
            // TODO: Tu fais quoi si erreur 404 ou 500 ??
            this.fields = await Services.Fields.getFields()
                .catch((res) => {
                    switch (res.status) {
                        case 401:
                            this.$router.push({ name: "Login" });
                            break;
                    }
                });
        }
    },
    async mounted() {
        this.$store.commit(SET_LOADING, true);
        await this.loadFields();
        this.$store.commit(SET_LOADING, false);
    },
}
</script>
<style lang="css" scoped>
.field {
    width: 1550px;
    margin: auto;
}
</style>